import { NodeProp, SyntaxNode } from "@lezer/common";
import { EditorState, Facet, StateField, Extension } from "@codemirror/state";
import { EditorView, BlockInfo, Command, DecorationSet, KeyBinding, ViewUpdate } from "@codemirror/view";
export declare const foldService: Facet<(state: EditorState, lineStart: number, lineEnd: number) => ({
    from: number;
    to: number;
} | null), readonly ((state: EditorState, lineStart: number, lineEnd: number) => ({
    from: number;
    to: number;
} | null))[]>;
export declare const foldNodeProp: NodeProp<(node: SyntaxNode, state: EditorState) => ({
    from: number;
    to: number;
} | null)>;
export declare function foldInside(node: SyntaxNode): {
    from: number;
    to: number;
} | null;
export declare function foldable(state: EditorState, lineStart: number, lineEnd: number): {
    from: number;
    to: number;
};
declare type DocRange = {
    from: number;
    to: number;
};
export declare const foldEffect: import("@codemirror/state").StateEffectType<DocRange>;
export declare const unfoldEffect: import("@codemirror/state").StateEffectType<DocRange>;
export declare const foldState: StateField<DecorationSet>;
export declare function foldedRanges(state: EditorState): DecorationSet;
export declare const foldCode: Command;
export declare const unfoldCode: Command;
export declare const foldAll: Command;
export declare const unfoldAll: Command;
export declare const toggleFold: Command;
export declare const foldKeymap: readonly KeyBinding[];
interface FoldConfig {
    placeholderDOM?: ((view: EditorView, onclick: (event: Event) => void) => HTMLElement) | null;
    placeholderText?: string;
}
export declare function codeFolding(config?: FoldConfig): Extension;
declare type Handlers = {
    [event: string]: (view: EditorView, line: BlockInfo, event: Event) => boolean;
};
interface FoldGutterConfig {
    markerDOM?: ((open: boolean) => HTMLElement) | null;
    openText?: string;
    closedText?: string;
    domEventHandlers?: Handlers;
    foldingChanged?: (update: ViewUpdate) => boolean;
}
export declare function foldGutter(config?: FoldGutterConfig): Extension;
export {};
