import { NodeType } from "@lezer/common";
import { Tag, Highlighter } from "@lezer/highlight";
import { StyleSpec, StyleModule } from "style-mod";
import { EditorState, Extension } from "@codemirror/state";
import { Language } from "./language";
export declare class HighlightStyle implements Highlighter {
    readonly specs: readonly TagStyle[];
    readonly module: StyleModule | null;
    readonly themeType: "dark" | "light" | undefined;
    readonly style: (tags: readonly Tag[]) => string | null;
    readonly scope: ((type: NodeType) => boolean) | undefined;
    private constructor();
    static define(specs: readonly TagStyle[], options?: {
        scope?: Language | NodeType;
        all?: string | StyleSpec;
        themeType?: "dark" | "light";
    }): HighlightStyle;
}
export declare function syntaxHighlighting(highlighter: Highlighter, options?: {
    fallback: boolean;
}): Extension;
export declare function highlightingFor(state: EditorState, tags: readonly Tag[], scope?: NodeType): string | null;
export interface TagStyle {
    tag: Tag | readonly Tag[];
    class?: string;
    [styleProperty: string]: any;
}
export declare const defaultHighlightStyle: HighlightStyle;
