import { NodeProp, SyntaxNode } from "@lezer/common";
import { EditorState, Extension, Facet } from "@codemirror/state";
export declare const indentService: Facet<(context: IndentContext, pos: number) => number | null | undefined, readonly ((context: IndentContext, pos: number) => number | null | undefined)[]>;
export declare const indentUnit: Facet<string, string>;
export declare function getIndentUnit(state: EditorState): number;
export declare function indentString(state: EditorState, cols: number): string;
export declare function getIndentation(context: IndentContext | EditorState, pos: number): number | null;
export declare function indentRange(state: EditorState, from: number, to: number): import("@codemirror/state").ChangeSet;
export declare class IndentContext {
    readonly state: EditorState;
    readonly options: {
        overrideIndentation?: (pos: number) => number;
        simulateBreak?: number;
        simulateDoubleBreak?: boolean;
    };
    unit: number;
    constructor(state: EditorState, options?: {
        overrideIndentation?: (pos: number) => number;
        simulateBreak?: number;
        simulateDoubleBreak?: boolean;
    });
    lineAt(pos: number, bias?: -1 | 1): {
        text: string;
        from: number;
    };
    textAfterPos(pos: number, bias?: -1 | 1): string;
    column(pos: number, bias?: -1 | 1): number;
    countColumn(line: string, pos?: number): number;
    lineIndent(pos: number, bias?: -1 | 1): number;
    get simulatedBreak(): number | null;
}
export declare const indentNodeProp: NodeProp<(context: TreeIndentContext) => number | null>;
export declare class TreeIndentContext extends IndentContext {
    private base;
    readonly pos: number;
    readonly node: SyntaxNode;
    private constructor();
    static create(base: IndentContext, pos: number, node: SyntaxNode): TreeIndentContext;
    get textAfter(): string;
    get baseIndent(): number;
    continue(): number;
}
export declare function delimitedIndent({ closing, align, units }: {
    closing: string;
    align?: boolean;
    units?: number;
}): (context: TreeIndentContext) => number;
export declare const flatIndent: (context: TreeIndentContext) => number;
export declare function continuedIndent({ except, units }?: {
    except?: RegExp;
    units?: number;
}): (context: TreeIndentContext) => number;
export declare function indentOnInput(): Extension;
