import { EditorState, Extension, Range } from "@codemirror/state";
import { Decoration } from "@codemirror/view";
import { SyntaxNode, NodeProp } from "@lezer/common";
export interface Config {
    afterCursor?: boolean;
    brackets?: string;
    maxScanDistance?: number;
    renderMatch?: (match: MatchResult, state: EditorState) => readonly Range<Decoration>[];
}
export declare function bracketMatching(config?: Config): Extension;
export declare const bracketMatchingHandle: NodeProp<(node: SyntaxNode) => SyntaxNode | null>;
export interface MatchResult {
    start: {
        from: number;
        to: number;
    };
    end?: {
        from: number;
        to: number;
    };
    matched: boolean;
}
export declare function matchBrackets(state: EditorState, pos: number, dir: -1 | 1, config?: Config): MatchResult | null;
