import { NodeType, NodeProp } from "@lezer/common";
import { Tag } from "@lezer/highlight";
import { Language } from "./language";
import { IndentContext } from "./indent";
import { StringStream } from "./stringstream";
export { StringStream };
export interface StreamParser<State> {
    name?: string;
    startState?(indentUnit: number): State;
    token(stream: StringStream, state: State): string | null;
    blankLine?(state: State, indentUnit: number): void;
    copyState?(state: State): State;
    indent?(state: State, textAfter: string, context: IndentContext): number | null;
    languageData?: {
        [name: string]: any;
    };
    tokenTable?: {
        [name: string]: Tag;
    };
}
export declare class StreamLanguage<State> extends Language {
    streamParser: Required<StreamParser<State>>;
    stateAfter: NodeProp<State>;
    tokenTable: TokenTable;
    topNode: NodeType;
    private constructor();
    static define<State>(spec: StreamParser<State>): StreamLanguage<State>;
    private getIndent;
    get allowsNesting(): boolean;
}
declare class TokenTable {
    readonly extra: {
        [name: string]: Tag;
    };
    table: {
        [name: string]: number;
    };
    constructor(extra: {
        [name: string]: Tag;
    });
    resolve(tag: string): number;
}
